package org.embulk.parser.header_based_csv.tokenizer

import org.embulk.standards.CsvTokenizer

import scala.collection.mutable

object TokenizerHelper {

  implicit class RichCsvTokenizer(tokenizer: CsvTokenizer) {
    def forEachRecord(f: Map[String, String] => Unit): Unit = {
      val header: Seq[String] = if (tokenizer.nextRecord()) parseLine(tokenizer) else Seq.empty
      while (tokenizer.nextRecord()) {
        val values = parseLine(tokenizer)
        val record = header.zip(values).toMap
        f(record)
      }
    }
  }

  private def parseLine(tokenizer: CsvTokenizer): Seq[String] = {
    val values = mutable.ListBuffer.empty[String]
    while (tokenizer.hasNextColumn) {
      values += tokenizer.nextColumn()
    }
    values.reverse.toList
  }

}
